
//--------------------------------------------------------------
// http://www.tradingrobot.nl
//--------------------------------------------------------------

#property copyright "Copyright  2012, Jonkie76"
#property link      "http://www.tradingrobot.nl/"

#include <stdlib.mqh>
#include <WinUser32.mqh>

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 SeaGreen
#property indicator_color2 Red

double Buy[];
double Sell[];

double CandleLength;
double BodyLength;
double UpperWick;
double LowerWick;
string CandleDirection;
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   ObjectsDeleteAll();
   SetIndexStyle(0, DRAW_NONE, EMPTY,3);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, Buy);
   SetIndexStyle(1, DRAW_NONE, EMPTY,3);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, Sell);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;

   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++) {

//---- Calculating length of candlewicks, and its body

if(Close[i+1] > Close[i+2])
   {
   CandleDirection="Bullish";
   BodyLength=Close[i+1]-Open[i+1];
   UpperWick=High[i+1]-Close[i+1];
   LowerWick=Open[i+1]-Low[i+1];
   }
else
   {
   CandleDirection="Bearish";
   BodyLength=Open[i+1]-Close[i+1];
   UpperWick=High[i+1]-Open[i+1];
   LowerWick=Close[i+1]-Low[i+1];
   }   

   CandleLength=High[i+1]-Low[i+1];

      
      if ( (((100.0/CandleLength)*BodyLength)<=35) && ( (((100.0/CandleLength)*UpperWick)>=50.0) || (((100.0/CandleLength)*LowerWick)>=50.0) ) && iClose(Symbol(),60,1) > iClose(Symbol(),60,4))
      {
         Buy[i] = Close[i+1];
         SetLevel(true,i+1,Close[i+1]);
      }
      else if ( (((100.0/CandleLength)*BodyLength)<=35) && ( (((100.0/CandleLength)*UpperWick)>=50.0) || (((100.0/CandleLength)*LowerWick)>=50.0) ) && iClose(Symbol(),60,1) < iClose(Symbol(),60,4))
      {
          Sell[i] = Close[i+1];
          SetLevel(true,i+1,Close[i+1]);
      }
        
  }
   return(0);
}
//--- functions

void SetLevel(bool bs,int co,double pr)
   {
   color cl;
   if(bs)
   {
   cl = Blue;
   }
   else
   {
   cl = Red;
   }
   string nm = "Level_"+Time[co];
   if(ObjectFind(nm)!=0){ObjectCreate(nm,2,0,0,0,0,0);}
      ObjectSet(nm,OBJPROP_TIME1,Time[co]+Period()*60*2);
      ObjectSet(nm,OBJPROP_TIME2,Time[co]);
      ObjectSet(nm,OBJPROP_PRICE1,pr);
      ObjectSet(nm,OBJPROP_PRICE2,pr);
      ObjectSet(nm,OBJPROP_COLOR,cl);
      ObjectSet(nm,OBJPROP_WIDTH,1);
      ObjectSet(nm,OBJPROP_STYLE,0);
      ObjectSet(nm,OBJPROP_RAY,false);
   return;
   }  